diff -Nrup -x '*.orig' -x '*.rej' -x '*.*~' ../SUNWgnome-file-mgr-2.30.0-b4/nautilus-2.30.1/configure.in nautilus-2.30.1/configure.in
--- ../SUNWgnome-file-mgr-2.30.0-b4/nautilus-2.30.1/configure.in	2010-05-14 17:16:20.583765747 +0200
+++ nautilus-2.30.1/configure.in	2010-05-14 17:16:39.539580939 +0200
@@ -232,6 +232,52 @@ if test "x$enable_packagekit" != "xno"; 
 	msg_packagekit=yes
 	AC_DEFINE(ENABLE_PACKAGEKIT, 1, [define to enable PackageKit mimetype installer])
 fi
+dnl ==========================================================================
+
+dnl ********************
+dnl * Check for libzfs *
+dnl ********************
+ZFS_LIBS=
+msg_zfs=no
+AC_CHECK_LIB(zfs, zfs_iter_root,
+   [AC_CHECK_HEADER(libzfs.h,
+       [AC_DEFINE(HAVE_ZFS, 1, [Define to 1 if ZFS is available])
+        ZFS_LIBS="-lzfs"
+        msg_zfs=yes])
+     ])
+AC_SUBST(ZFS_LIBS)
+
+dnl ==========================================================================
+
+dnl ********************
+dnl * Check for libscf*
+dnl ********************
+SCF_LIBS=
+msg_scf=no
+AC_CHECK_LIB(scf, scf_handle_bind,
+   [AC_CHECK_HEADER(libscf.h,
+       [AC_DEFINE(HAVE_SCF, 1, [Define to 1 if SCF is available])
+        SCF_LIBS="-lscf"
+        msg_scf=yes])
+     ])
+AC_SUBST(SCF_LIBS)
+
+dnl ==========================================================================
+
+dnl ********************
+dnl * Check for libscf*
+dnl ********************
+NVPAIR_LIBS=
+msg_nvpair=no
+AC_CHECK_LIB(nvpair, nvpair_value_match,
+   [AC_CHECK_HEADER(libscf.h,
+       [AC_DEFINE(NVPAIR_LIBS, 1, [Define to 1 if nvpair is available])
+        NVPAIR_LIBS="-lnvpair"
+        msg_nvpair=yes])
+     ])
+AC_SUBST(NVPAIR_LIBS)
+
+
 
 dnl ==========================================================================
 
--- nautilus-3.1.3/icons/Makefile.am.orig	2011-04-04 19:01:22.000000000 +0100
+++ nautilus-3.1.3/icons/Makefile.am	2011-07-22 09:20:35.708887571 +0100
@@ -4,7 +4,11 @@
 
 icon_DATA =\
 	audio.svg \
+	camera.png \
 	knob.png \
+	restore.png \
+	restore-no.png \
+	restore-search.png \
 	thumbnail_frame.png \
 	$(NULL)
 
--- nautilus-3.1.3/libnautilus-private/Makefile.am.orig	2011-07-22 09:23:13.721321695 +0100
+++ nautilus-3.1.3/libnautilus-private/Makefile.am	2011-07-22 09:27:45.285633388 +0100
@@ -49,6 +49,9 @@
 	$(BASE_LIBS)			\
 	$(COMMON_LIBS)			\
 	$(NAUTILUS_LIBS)		\
+	$(ZFS_LIBS)			\
+	$(SCF_LIBS)			\
+	$(NVPAIR_LIBS)			\
 	$(NULL)
 
 libnautilus_private_la_SOURCES = \
@@ -192,6 +195,8 @@
 	nautilus-vfs-directory.h \
 	nautilus-vfs-file.c \
 	nautilus-vfs-file.h \
+	nautilus-zfs.c \
+	nautilus-zfs.h \
 	$(NULL)
 
 nodist_libnautilus_private_la_SOURCES =\
--- nautilus-3.1.3/libnautilus-private/org.gnome.nautilus.gschema.xml.in.orig	2011-07-22 09:34:01.449051792 +0100
+++ nautilus-3.1.3/libnautilus-private/org.gnome.nautilus.gschema.xml.in	2011-07-22 09:38:31.164878925 +0100
@@ -72,6 +72,11 @@
       <_summary>Where to position newly open tabs in browser windows.</_summary>
       <_description>If set to "after-current-tab", then new tabs are inserted after the current tab. If set to "end", then new tabs are appended to the end of the tab list.</_description>
     </key>
+    <key name="enable-time-slider" type="b">
+      <default>true</default>
+      <_summary>Enables the visualization of ZFS snapshots timeline</_summary>
+      <_description>If set to true, the visualization of the ZFS snapshots timeline is enabled.</_description>
+    </key>
     <key name="always-use-browser" type="b">
       <default>true</default>
       <_summary>Enables the classic Nautilus behavior, where all windows are browsers</_summary>
--- nautilus-3.1.3/libnautilus-private/nautilus-column-utilities.c.orig	2011-04-04 19:01:22.000000000 +0100
+++ nautilus-3.1.3/libnautilus-private/nautilus-column-utilities.c	2011-07-22 09:46:21.698069053 +0100
@@ -129,6 +129,15 @@
 					       "label", _("Location"),
 					       "description", _("The location of the file."),
 					       NULL));
+	columns = g_list_append (columns,
+				 g_object_new (NAUTILUS_TYPE_COLUMN,
+					       "name", "restore_info",
+					       "attribute", "restore_info",
+					       /* SUN_BRANDING */
+					       "label", _("Restore information"),
+					       /* SUN_BRANDING */
+					       "description", _("Restore information of the file."),
+					       NULL));
 
 	return columns;
 }
diff -Nrup -x '*.orig' -x '*.rej' -x '*.*~' ../SUNWgnome-file-mgr-2.30.0-b4/nautilus-2.30.1/libnautilus-private/nautilus-directory-async.c nautilus-2.30.1/libnautilus-private/nautilus-directory-async.c
--- ../SUNWgnome-file-mgr-2.30.0-b4/nautilus-2.30.1/libnautilus-private/nautilus-directory-async.c	2010-05-14 17:16:20.620971445 +0200
+++ nautilus-2.30.1/libnautilus-private/nautilus-directory-async.c	2010-05-14 17:16:39.543203000 +0200
@@ -658,6 +658,7 @@ remove_monitor_link (NautilusDirectory *
 		g_list_free_1 (link);
 	}
 }
+	
 
 static void
 remove_monitor (NautilusDirectory *directory,
@@ -722,6 +723,10 @@ nautilus_directory_set_up_request (Nauti
 		REQUEST_SET_TYPE (request, REQUEST_FILESYSTEM_INFO);
 	}
 
+	if (file_attributes & NAUTILUS_FILE_ATTRIBUTE_RESTORE_INFO) {
+		REQUEST_SET_TYPE (request, REQUEST_RESTORE_INFO);
+	}
+
 	return request;
 }
 
@@ -4759,6 +4764,18 @@ cancel_link_info_for_file (NautilusDirec
 	}
 }
 
+void nautilus_directory_cancel_restore_info (NautilusDirectory *directory)
+{
+  if (NAUTILUS_IS_DIRECTORY (directory))
+    {
+      if (directory->details->restore_cancel)
+	{
+	  g_cancellable_cancel (directory->details->restore_cancel);
+	  directory->details->restore_cancel = NULL;
+	}
+    }
+}
+
 
 static void
 cancel_loading_attributes (NautilusDirectory *directory,
@@ -4801,7 +4818,9 @@ cancel_loading_attributes (NautilusDirec
 	if (REQUEST_WANTS_TYPE (request, REQUEST_MOUNT)) {
 		mount_cancel (directory);
 	}
-	
+        if (REQUEST_WANTS_TYPE (request, REQUEST_RESTORE_INFO)) {
+            nautilus_directory_cancel_restore_info (directory);
+        }
 	nautilus_directory_async_state_changed (directory);
 }
 
@@ -4843,7 +4862,9 @@ nautilus_directory_cancel_loading_file_a
 	if (REQUEST_WANTS_TYPE (request, REQUEST_MOUNT)) {
 		cancel_mount_for_file (directory, file);
 	}
-
+        if (REQUEST_WANTS_TYPE (request, REQUEST_RESTORE_INFO)) {
+            nautilus_directory_cancel_restore_info (directory);
+        }
 	nautilus_directory_async_state_changed (directory);
 }
 
diff -Nrup -x '*.orig' -x '*.rej' -x '*.*~' ../SUNWgnome-file-mgr-2.30.0-b4/nautilus-2.30.1/libnautilus-private/nautilus-directory-private.h nautilus-2.30.1/libnautilus-private/nautilus-directory-private.h
--- ../SUNWgnome-file-mgr-2.30.0-b4/nautilus-2.30.1/libnautilus-private/nautilus-directory-private.h	2009-12-09 12:03:51.000000000 +0100
+++ nautilus-2.30.1/libnautilus-private/nautilus-directory-private.h	2010-05-14 17:16:39.543661242 +0200
@@ -58,6 +58,7 @@ typedef enum {
 	REQUEST_THUMBNAIL,
 	REQUEST_MOUNT,
 	REQUEST_FILESYSTEM_INFO,
+	REQUEST_RESTORE_INFO,
 	REQUEST_TYPE_LAST
 } RequestType;
 
@@ -140,6 +141,9 @@ struct NautilusDirectoryDetails
 
 	guint64 free_space; /* (guint)-1 for unknown */
 	time_t free_space_read; /* The time free_space was updated, or 0 for never */
+	GCancellable *restore_cancel;
+	/* zfs snapshot info */
+ 	GList *zfs_snapshots;
 };
 
 NautilusDirectory *nautilus_directory_get_existing                    (GFile                     *location);
--- nautilus-3.1.3/libnautilus-private/nautilus-directory.c.orig	2011-07-22 15:39:09.879596935 +0100
+++ nautilus-3.1.3/libnautilus-private/nautilus-directory.c	2011-07-22 15:46:56.201033321 +0100
@@ -35,6 +35,7 @@
 #include "nautilus-metadata.h"
 #include "nautilus-desktop-directory.h"
 #include "nautilus-vfs-directory.h"
+#include "nautilus-zfs.h"
 #include <eel/eel-glib-extensions.h>
 #include <eel/eel-gtk-macros.h>
 #include <eel/eel-string.h>
@@ -129,6 +130,8 @@
 	directory->details->low_priority_queue = nautilus_file_queue_new ();
 	directory->details->extension_queue = nautilus_file_queue_new ();
 	directory->details->free_space = (guint64)-1;
+        directory->details->zfs_snapshots = NULL;
+        directory->details->restore_cancel = NULL;
 }
 
 NautilusDirectory *
@@ -160,7 +163,7 @@
 nautilus_directory_finalize (GObject *object)
 {
 	NautilusDirectory *directory;
-
+	
 	directory = NAUTILUS_DIRECTORY (object);
 
 	g_hash_table_remove (directories, directory->details->location);
@@ -196,7 +199,13 @@
 	if (directory->details->hidden_file_hash) {
 		g_hash_table_destroy (directory->details->hidden_file_hash);
 	}
-	
+
+	if (directory->details->zfs_snapshots) {
+	        ts_free_snapshots (directory->details->zfs_snapshots);
+	}
+	if (directory->details->restore_cancel)
+	  g_cancellable_cancel (directory->details->restore_cancel);
+
 	nautilus_file_queue_destroy (directory->details->high_priority_queue);
 	nautilus_file_queue_destroy (directory->details->low_priority_queue);
 	nautilus_file_queue_destroy (directory->details->extension_queue);
@@ -308,11 +317,26 @@
 	g_hash_table_foreach (directories, async_state_changed_one, NULL);
 }
 
+static gboolean time_slider_enabled = TRUE;
+
+gboolean is_time_slider_enabled ()
+{
+	return time_slider_enabled;
+}
+
+static void time_slider_pref_changed_callback (gpointer callback_data)
+{
+	time_slider_enabled = g_settings_get_boolean(nautilus_preferences,
+				NAUTILUS_PREFERENCES_ENABLE_TIME_SLIDER);
+}
+
 static void
 add_preferences_callbacks (void)
 {
 	nautilus_global_preferences_init ();
 
+	time_slider_enabled = g_settings_get_boolean(nautilus_preferences,
+				NAUTILUS_PREFERENCES_ENABLE_TIME_SLIDER);
 	g_signal_connect_swapped (nautilus_preferences,
 				  "changed::" NAUTILUS_PREFERENCES_SHOW_HIDDEN_FILES,
 				  G_CALLBACK(filtering_changed_callback),
@@ -330,6 +354,10 @@
 				  "changed::" NAUTILUS_PREFERENCES_DATE_FORMAT,
 				  G_CALLBACK(async_data_preference_changed_callback),
 				  NULL);
+	g_signal_connect_swapped (nautilus_preferences,
+				  "changed::" NAUTILUS_PREFERENCES_ENABLE_TIME_SLIDER,
+				  G_CALLBACK(time_slider_pref_changed_callback),
+				  NULL);
 }
 
 static void
@@ -534,6 +562,7 @@
 {
 	NautilusDirectory *directory;
 	char *uri;
+	char *path;
 
 	uri = g_file_get_uri (location);
 	
@@ -545,10 +574,13 @@
 		directory = NAUTILUS_DIRECTORY (nautilus_search_directory_new_from_saved_search (uri));
 	} else {
 		directory = NAUTILUS_DIRECTORY (g_object_new (NAUTILUS_TYPE_VFS_DIRECTORY, NULL));
+		path = g_file_get_path (location);
+		g_free (path);
 	}
 
 	set_directory_location (directory, location);
 
+
 	g_free (uri);
 	
 	return directory;
@@ -567,6 +599,201 @@
 	       g_file_is_native (directory->details->location);
 }
 
+typedef struct {
+  NautilusDirectory         *dir;
+  GCancellable	            *cancel;
+  TsReadyCallback	     callback;
+  gpointer		     callback_user_data;
+} QuerySnapshotsAsyncData;
+
+
+static void snapshot_list_ready_callback (GObject *source_object,
+					  GAsyncResult *res,
+					  gpointer user_data)
+{
+  GSimpleAsyncResult *simple = G_SIMPLE_ASYNC_RESULT (res);
+  QuerySnapshotsAsyncData *data = (QuerySnapshotsAsyncData*) user_data;
+
+  if (!g_cancellable_is_cancelled (data->cancel))
+    {
+      data->dir->details->zfs_snapshots = g_simple_async_result_get_op_res_gpointer (simple);
+    }
+
+  data->callback (data->dir, data->cancel, data->callback_user_data);
+}
+
+void
+nautilus_directory_get_snapshots_async (NautilusDirectory *directory, 
+					TsReadyCallback ready_callback, 
+					GCancellable *cancel, 
+					gpointer      callback_user_data)
+{
+	g_assert (NAUTILUS_IS_DIRECTORY (directory));
+	
+	if (directory->details->location == NULL) 
+	  return;
+
+	if (directory->details->zfs_snapshots) {
+	  ts_free_snapshots (directory->details->zfs_snapshots);
+	  directory->details->zfs_snapshots = NULL;
+	}
+	
+	if (is_time_slider_enabled ())
+	  {
+	    QuerySnapshotsAsyncData *data;
+	    data = g_new0 (QuerySnapshotsAsyncData,1);
+	    data->dir = directory;
+	    data->cancel = cancel;
+	    data->callback = ready_callback;
+	    data->callback_user_data = callback_user_data;
+
+	    ts_get_snapshots_for_dir_async (directory->details->location, 
+					    snapshot_list_ready_callback, 
+					    cancel,
+					    data);
+	  }
+}
+
+gboolean
+nautilus_directory_has_snapshots (NautilusDirectory *directory)
+{
+	g_assert (NAUTILUS_IS_DIRECTORY (directory));
+	
+	if (directory->details->zfs_snapshots)
+	  return TRUE;
+
+	return FALSE;
+}
+int
+nautilus_directory_get_num_snapshots (NautilusDirectory	*directory)
+{
+  g_assert (NAUTILUS_IS_DIRECTORY (directory));
+
+    if (directory->details->zfs_snapshots)
+      {
+	int i = 0;
+	GList *tmp;
+	for (tmp = directory->details->zfs_snapshots;tmp;tmp = tmp->next)
+	  i++;
+	return i;
+      }
+    return 0;
+}
+
+gboolean           
+nautilus_directory_is_in_snapshot (NautilusDirectory         *directory)
+{
+  char *directory_uri;
+  gboolean result = FALSE;
+
+  g_return_val_if_fail (NAUTILUS_IS_DIRECTORY (directory), FALSE);
+  
+  directory_uri = nautilus_directory_get_uri (directory);
+  
+  result = ts_is_in_snapshot (directory_uri);
+
+  g_free (directory_uri);
+
+  return result;
+}
+
+GList *
+nautilus_directory_get_snapshots (NautilusDirectory *directory)
+{
+  g_assert (NAUTILUS_IS_DIRECTORY (directory));
+
+  return directory->details->zfs_snapshots;
+}
+
+void  nautilus_directory_remove_snapshot (NautilusDirectory *directory,
+					  ZfsDataSet *snap)
+{
+  if (directory->details->zfs_snapshots)
+    {
+      directory->details->zfs_snapshots = g_list_remove (directory->details->zfs_snapshots, snap);
+      ts_free_zfs_dataset (snap);
+    }
+}
+/* return true if snapdir dir path is a dir or subdir of refdir */
+gboolean 
+nautilus_directory_is_a_snapshot_dir_of (NautilusDirectory *snapdir,
+					 NautilusDirectory *refdir)
+{
+
+   gboolean result = FALSE;   
+
+  if (nautilus_directory_is_in_snapshot (snapdir))
+    {
+      char snapdir_root_real_path [PATH_MAX+1];
+      char refdir_real_path [PATH_MAX+1];
+      NautilusDirectory *snapdir_root = nautilus_directory_get_snap_root (snapdir);
+      GFile *snapdir_root_file = nautilus_directory_get_location (snapdir_root);
+      GFile *refdir_file = nautilus_directory_get_location (refdir);
+      char* snapdir_root_path = g_file_get_path (snapdir_root_file);
+      char* refdir_path = g_file_get_path (refdir_file);
+      
+      if (ts_realpath (snapdir_root_path, snapdir_root_real_path) && 
+	      ts_realpath (refdir_path, refdir_real_path))
+	    {
+	      if (g_strrstr (snapdir_root_real_path,refdir_real_path))
+		result = TRUE;
+	    }
+
+	  g_free (snapdir_root_path);
+	  g_free (refdir_path);
+	  g_object_unref (snapdir_root_file);
+	  g_object_unref (refdir_file);
+	  g_object_unref (snapdir_root);
+    }
+
+  return result;
+}
+
+NautilusDirectory *nautilus_directory_get_snap_root (NautilusDirectory	  *directory)
+{
+  char *directory_uri, *snap_root;
+  char *zfs, *iter;
+  int count = 0;
+  NautilusDirectory *new_dir;
+
+  g_assert (NAUTILUS_IS_DIRECTORY (directory));
+  
+  directory_uri = nautilus_directory_get_uri (directory);
+
+
+  if (!nautilus_directory_is_in_snapshot (directory))
+    {
+      g_free (directory_uri);
+      return directory;
+    }
+
+  /*remove .zfs/snapshot/blah/ */
+  zfs = g_strrstr (directory_uri, ".zfs/snapshot/");
+  iter = zfs;
+
+  if (iter)
+    {
+      iter += sizeof (".zfs/snapshot/");
+      while (*iter != '/' && *iter != '\0')
+	iter++;
+
+      if (*iter == '/')
+	iter++;
+      
+      *zfs = '\0';
+      snap_root = g_strdup_printf ("%s%s", directory_uri, iter);
+      
+      *zfs = 'a';
+      g_free (directory_uri);
+      new_dir = nautilus_directory_get_by_uri (snap_root);
+      g_free (snap_root);
+      return new_dir;
+    }
+  return directory;
+}
+
+
+
 gboolean
 nautilus_directory_is_in_trash (NautilusDirectory *directory)
 {
diff -Nrup -x '*.orig' -x '*.rej' -x '*.*~' ../SUNWgnome-file-mgr-2.30.0-b4/nautilus-2.30.1/libnautilus-private/nautilus-directory.h nautilus-2.30.1/libnautilus-private/nautilus-directory.h
--- ../SUNWgnome-file-mgr-2.30.0-b4/nautilus-2.30.1/libnautilus-private/nautilus-directory.h	2009-12-08 16:17:07.000000000 +0100
+++ nautilus-2.30.1/libnautilus-private/nautilus-directory.h	2010-05-14 17:16:39.545571596 +0200
@@ -28,6 +28,7 @@
 #include <gtk/gtk.h>
 #include <gio/gio.h>
 #include <libnautilus-private/nautilus-file-attributes.h>
+#include <libnautilus-private/nautilus-zfs.h>
 
 /* NautilusDirectory is a class that manages the model for a directory,
    real or virtual, for Nautilus, mainly the file-manager component. The directory is
@@ -219,6 +220,24 @@ gboolean           nautilus_directory_ar
 gboolean           nautilus_directory_is_local                 (NautilusDirectory         *directory);
 
 gboolean           nautilus_directory_is_in_trash              (NautilusDirectory         *directory);
+typedef void (*TsReadyCallback) (NautilusDirectory *directory,
+				 GCancellable	   *cancellable,
+				 gpointer           callback_data);
+
+void		   nautilus_directory_get_snapshots_async      (NautilusDirectory	  *directory, 
+								TsReadyCallback		   ready_callback, 
+								GCancellable		  *cancel, 
+								gpointer		   callback_user_data);
+gboolean           nautilus_directory_has_snapshots            (NautilusDirectory         *directory);
+gboolean           nautilus_directory_is_in_snapshot           (NautilusDirectory         *directory);
+int		   nautilus_directory_get_num_snapshots	       (NautilusDirectory	  *directory);
+GList *		   nautilus_directory_get_snapshots	       (NautilusDirectory	  *directory);
+void		   nautilus_directory_remove_snapshot	       (NautilusDirectory	  *directory,
+								ZfsDataSet		  *snap);
+NautilusDirectory *nautilus_directory_get_snap_root	       (NautilusDirectory	  *directory);
+gboolean	   nautilus_directory_is_a_snapshot_dir_of     (NautilusDirectory	  *snapdir,
+								NautilusDirectory	  *refdir);
+void		   nautilus_directory_cancel_restore_info      (NautilusDirectory	  *directory);
 
 /* Return false if directory contains anything besides a Nautilus metafile.
  * Only valid if directory is monitored. Used by the Trash monitor.
@@ -239,6 +258,7 @@ GList *            nautilus_directory_li
 gboolean           nautilus_directory_is_desktop_directory     (NautilusDirectory         *directory);
 
 gboolean           nautilus_directory_is_editable              (NautilusDirectory         *directory);
+gboolean	   is_time_slider_enabled ();
 
 
 #endif /* NAUTILUS_DIRECTORY_H */
diff -Nrup -x '*.orig' -x '*.rej' -x '*.*~' ../SUNWgnome-file-mgr-2.30.0-b4/nautilus-2.30.1/libnautilus-private/nautilus-file-attributes.h nautilus-2.30.1/libnautilus-private/nautilus-file-attributes.h
--- ../SUNWgnome-file-mgr-2.30.0-b4/nautilus-2.30.1/libnautilus-private/nautilus-file-attributes.h	2009-12-09 12:03:51.000000000 +0100
+++ nautilus-2.30.1/libnautilus-private/nautilus-file-attributes.h	2010-05-14 17:16:39.545856449 +0200
@@ -41,6 +41,7 @@ typedef enum {
 	NAUTILUS_FILE_ATTRIBUTE_THUMBNAIL = 1 << 8,
 	NAUTILUS_FILE_ATTRIBUTE_MOUNT = 1 << 9,
 	NAUTILUS_FILE_ATTRIBUTE_FILESYSTEM_INFO = 1 << 10,
+        NAUTILUS_FILE_ATTRIBUTE_RESTORE_INFO = 1 << 12,
 } NautilusFileAttributes;
 
 #endif /* NAUTILUS_FILE_ATTRIBUTES_H */
diff -Nrup -x '*.orig' -x '*.rej' -x '*.*~' ../SUNWgnome-file-mgr-2.30.0-b4/nautilus-2.30.1/libnautilus-private/nautilus-file-private.h nautilus-2.30.1/libnautilus-private/nautilus-file-private.h
--- ../SUNWgnome-file-mgr-2.30.0-b4/nautilus-2.30.1/libnautilus-private/nautilus-file-private.h	2009-12-09 12:03:51.000000000 +0100
+++ nautilus-2.30.1/libnautilus-private/nautilus-file-private.h	2010-05-14 17:16:39.546288851 +0200
@@ -146,6 +146,15 @@ struct NautilusFileDetails
 
 	/* Mount for mountpoint or the references GMount for a "mountable" */
 	GMount *mount;
+
+	/* time slider file difference information */
+
+	char *restore_info;
+
+        /* snapshot directory for versions */
+
+        char *snapshot_directory;
+        GCancellable *has_snapshot_cancel;
 	
 	/* boolean fields: bitfield to save space, since there can be
            many NautilusFile objects. */
@@ -194,6 +203,13 @@ struct NautilusFileDetails
 	
 	eel_boolean_bit is_thumbnailing               : 1;
 
+	eel_boolean_bit restore_info_is_up_to_date    : 1;
+	eel_boolean_bit restore_info_in_progress      : 1;
+
+        eel_boolean_bit has_snap_versions_is_up_to_date    : 1;
+	eel_boolean_bit has_snap_versions_in_progress      : 1;
+        eel_boolean_bit has_snap_versions                  : 1;
+
 	/* TRUE if the file is open in a spatial window */
 	eel_boolean_bit has_open_window               : 1;
 
